<?php
namespace Teknisa\EST\Modules\Relatorios\Factories;

use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Est70000ResumoDeOperacoesFactory {

    protected $connection;

	public function __construct($entityManager) {
		$this->connection = $entityManager->getConnection();
	}
	
    // 	This function gets groupFili data on DB
    public function getGroupFiliInfo($params){
    	$sql = "SELECT DISTINCT CDFILISUBGR
				  FROM PRSUBGRPROD
			 	 WHERE CDGRUPPROD = :CDGRUPPROD
			 	 ORDER BY CDFILISUBGR ASC";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    // 	This function gets sales data on DB
    public function getSalesInfo($params){
    	$sql = "SELECT
                    G.CDSUBGRPROD              AS CDSUBGRPROD,
                    NVL(SUM(E.VLRLIQUIDO), 0)  AS VLRLIQUIDO,
                    NVL(SUM(E.VLRBRUTO), 0)    AS VLRBRUTO,
                    NVL(SUM(E.VRDEVOLUCAO), 0) AS VRDEVOLUCAO,
                    E.CDLOCALESTOQ
                FROM
                    SUBGRUPPROD G,
                    (
                        SELECT
                            NT.CDSUBGRPROD,
                            NT.VLRLIQUIDO,
                            NT.VLRBRUTO,
                            VRDEVOLUCAO,
                            NT.CDLOCALESTOQ
                        FROM
                            (
                                SELECT
                                    AN.CDGRUPPROD,
                                    AN.CDSUBGRPROD,
                                    DECODE(CDTIPOOPER, '06', 0, SUM(I.VRCONTITEM))            VLRBRUTO,
                                    DECODE(CDTIPOOPER, '06', 0, SUM(VRTOTAITEM - VRDESCITEM)) VLRLIQUIDO,
                                    DECODE(CDTIPOOPER, '06', SUM(I.VRCONTITEM), 0)            VRDEVOLUCAO,
                                    I.CDLOCALESTOQ
                                FROM
                                    PRSUBGRPROD AN,
                                    PRODUTO     P,
                                    NOTAFISCAL  N,
                                    ITEMPRODUTO I
                                WHERE
                                    ( N.CDFILIEMIT = :CDFILIAL )
                                    AND ( N.IDENTRSAIDOP = 'S' )
                                    AND ( N.DTENTRSAID BETWEEN :DTINICIAL AND :DTFINAL )
                                    AND ( I.CDFILIAL = N.CDFILIAL )
                                    AND ( I.NRLANCTONF = N.NRLANCTONF )
                                    AND ( I.CDALMOXARIFE = :CDALMOXARIFE )
                                    AND ( I.CDLOCALESTOQ = :CDLOCALESTOQ )
                                    AND ( AN.CDPRODUTO = I.CDPRODUTO )
                                    AND ( AN.CDGRUPPROD = :CDGRUPPROD )
                                    AND ( AN.CDFILISUBGR = :CDFILISUBGR )
                                    AND ( P.CDPRODUTO = I.CDPRODUTO )
                                    AND ( NVL(N.IDSISTEMA, 'DFS') IN ( 'DFS', 'FAI', 'PDV' ) )
                                GROUP BY
                                    AN.CDGRUPPROD,
                                    AN.CDSUBGRPROD,
                                    CDTIPOOPER,
                                    I.CDLOCALESTOQ
                            ) NT
                    )E
                WHERE
                    ( G.CDGRUPPROD = :CDGRUPPROD )
                    AND ( G.CDSUBGRPROD = E.CDSUBGRPROD (+) )
                GROUP BY
                    G.NRORG,
                    G.CDSUBGRPROD,
                    E.CDLOCALESTOQ
                ORDER BY
                    G.CDSUBGRPROD";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    // 	This function gets nf data on DB
    public function getNfInfo($params){
    	$sql = "SELECT
                    G.CDSUBGRPROD AS CDSUBGRPROD,
                    NVL(E.VLRTOTAL,0) AS VLRTOTALNF, 
                    NVL(E.CDLOCALESTOQ,0) AS CDLOCALESTOQ
                FROM
                    SUBGRUPPROD G,
                    (
                        SELECT
                            NT.CDSUBGRPROD,
                            NT.VLRTOTAL,
                            NT.CDLOCALESTOQ
                        FROM
                            (
                                SELECT
                                    AN.CDGRUPPROD,
                                    AN.CDSUBGRPROD,
                                    SUM(I.VRCONTITEM) VLRTOTAL,
                                    I.CDLOCALESTOQ
                                FROM
                                    PRSUBGRPROD AN,
                                    PRODUTO     P,
                                    NOTAFISCAL  N,
                                    ITEMPRODUTO I
                                WHERE
                                    ( N.CDFILIRECE = :CDFILIAL )
                                    AND ( N.IDENTRSAIDOP = 'E' )
                                    AND ( N.DTENTRSAID BETWEEN :DTINICIAL AND :DTFINAL )
                                    AND ( I.CDFILIAL = N.CDFILIAL )
                                    AND ( I.NRLANCTONF = N.NRLANCTONF )
                                    AND ( I.CDALMOXARIFE = :CDALMOXARIFE )
                                    AND ( I.CDLOCALESTOQ = :CDLOCALESTOQ )
                                    AND ( AN.CDPRODUTO = I.CDPRODUTO )
                                    AND ( AN.CDGRUPPROD = :CDGRUPPROD )
                                    AND ( AN.CDFILISUBGR = :CDFILISUBGR )
                                    AND ( P.CDPRODUTO = I.CDPRODUTO )
                                GROUP BY
                                    AN.CDGRUPPROD,
                                    AN.CDSUBGRPROD,
                                    I.CDLOCALESTOQ
                            ) NT
                    )           E
                WHERE
                    ( G.CDGRUPPROD = :CDGRUPPROD )
                    AND ( G.CDSUBGRPROD = E.CDSUBGRPROD (+) )
                ORDER BY
                    G.CDSUBGRPROD";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    // 	This function gets transfer data on DB
    public function getTransferInfo($params){
    	$sql = "SELECT
                    G.CDSUBGRPROD             AS CDSUBGRPROD,
                    NVL(SUM(VLRTSIMPENTR), 0) AS VLRTSIMPENTR,
                    NVL(SUM(VLRTSIMPSAID), 0) AS VLRTSIMPSAID,
                    E.CDLOCALESTOQ
                FROM
                    SUBGRUPPROD G,
                    (
                        SELECT
                            NT.CDSUBGRPROD,
                            NT.VLRTSIMPENTR,
                            NT.VLRTSIMPSAID,
                            NT.CDLOCALESTOQ
                        FROM
                            (
                                SELECT
                                    AN.CDGRUPPROD,
                                    AN.CDSUBGRPROD,
                                    SUM(VRTOTLANCTO) VLRTSIMPENTR,
                                    0                VLRTSIMPSAID,
                                    I.CDLOCALESTOQ
                                FROM
                                    PRSUBGRPROD  AN,
                                    PRODUTO      P,
                                    LANCTOESTOQ  L,
                                    ITLANCTOEST  I,
                                    CTRLMOVIESTQ C
                                WHERE
                                    ( C.CDFILIAL = :CDFILIAL )
                                    AND ( C.DTMOVIESTQ BETWEEN :DTINICIAL AND :DTFINAL )
                                    AND ( C.CDFILIALENTR = L.CDFILIAL )
                                    AND ( C.NRLANESTENTR = L.NRLANCESTQ )
                                    AND ( I.CDFILIAL = L.CDFILIAL )
                                    AND ( I.NRLANCESTQ = L.NRLANCESTQ )
                                    AND ( I.CDALMOXARIFE = :CDALMOXARIFE )
                                    AND ( I.CDLOCALESTOQ = :CDLOCALESTOQ )
                                    AND ( AN.CDPRODUTO = I.CDPRODUTO )
                                    AND ( AN.CDGRUPPROD = :CDGRUPPROD )
                                    AND ( AN.CDFILISUBGR = :CDFILISUBGR )
                                    AND ( P.CDPRODUTO = I.CDPRODUTO )
                                GROUP BY
                                    AN.CDGRUPPROD,
                                    AN.CDSUBGRPROD,
                                    I.CDLOCALESTOQ
                                UNION ALL
                                SELECT
                                    AN.CDGRUPPROD,
                                    AN.CDSUBGRPROD,
                                    0                VLRTSIMPENTR,
                                    SUM(VRTOTLANCTO) VLRTSIMPSAID,
                                    I.CDLOCALESTOQ
                                FROM
                                    PRSUBGRPROD  AN,
                                    PRODUTO      P,
                                    LANCTOESTOQ  L,
                                    ITLANCTOEST  I,
                                    CTRLMOVIESTQ C
                                WHERE
                                    ( C.CDFILIAL = :CDFILIAL )
                                    AND ( C.DTMOVIESTQ BETWEEN :DTINICIAL AND :DTFINAL )
                                    AND ( C.CDFILIALSAID = L.CDFILIAL )
                                    AND ( C.NRLANESTSAID = L.NRLANCESTQ )
                                    AND ( I.CDFILIAL = L.CDFILIAL )
                                    AND ( I.NRLANCESTQ = L.NRLANCESTQ )
                                    AND ( I.CDALMOXARIFE = :CDALMOXARIFE )
                                    AND ( I.CDLOCALESTOQ = :CDLOCALESTOQ )
                                    AND ( AN.CDPRODUTO = I.CDPRODUTO )
                                    AND ( AN.CDGRUPPROD = :CDGRUPPROD )
                                    AND ( AN.CDFILISUBGR = :CDFILISUBGR )
                                    AND ( P.CDPRODUTO = I.CDPRODUTO )
                                GROUP BY
                                    AN.CDGRUPPROD,
                                    AN.CDSUBGRPROD,
                                    I.CDLOCALESTOQ
                            ) NT
                    )           E
                WHERE
                    ( G.CDGRUPPROD = :CDGRUPPROD )
                    AND ( G.CDSUBGRPROD = E.CDSUBGRPROD (+) )
                GROUP BY
                    G.CDSUBGRPROD,
                    E.CDLOCALESTOQ
                ORDER BY
                    G.CDSUBGRPROD";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    // 	This function gets daily stock data on DB
    public function getAverageStockInfo($params){
    	$sql = "SELECT
                    G.CDSUBGRPROD AS CDSUBGRPROD,
                    NVL(SUM(E.VRESTOQDIAF),0) AS VRESTOQDIAF
                FROM
                    SUBGRUPPROD G,
                    (
                        SELECT
                            P.CDLOCALESTOQ,
                            SUM(P.VRESTOQDIA) VRESTOQDIAF,
                            AN.CDSUBGRPROD
                        FROM
                            POSESTDIA   P,
                            PRODUTO     A,
                            PRSUBGRPROD AN
                        WHERE
                            ( P.CDFILIAL = :CDFILIAL )
                            AND ( P.CDALMOXARIFE = :CDALMOXARIFE )
                            AND ( P.CDLOCALESTOQ = NVL(:CDLOCALESTOQ, P.CDLOCALESTOQ) )
                            AND ( AN.CDGRUPPROD = :CDGRUPPROD )
                            AND ( AN.CDFILISUBGR = :CDFILISUBGR )
                            AND ( AN.CDPRODUTO = P.CDPRODUTO )
                            AND ( P.CDPRODUTO = A.CDPRODUTO )
                            AND ( P.DTPOSIESTQ = (
                                SELECT
                                    MAX(DTPOSIESTQ)
                                FROM
                                    POSESTDIA C
                                WHERE
                                    ( C.CDFILIAL = P.CDFILIAL )
                                    AND ( C.CDPRODUTO = P.CDPRODUTO )
                                    AND ( C.CDALMOXARIFE = P.CDALMOXARIFE )
                                    AND ( C.CDLOCALESTOQ = P.CDLOCALESTOQ )
                                    AND ( C.NRLOTEESTQ = P.NRLOTEESTQ )
                                    AND ( C.NRSUBLOTE = P.NRSUBLOTE )
                                    AND ( C.DTPOSIESTQ <= :DTPOSIESTQ)
                            ) )
                        GROUP BY
                            P.CDLOCALESTOQ,
                            AN.CDSUBGRPROD
                    )           E
                WHERE
                    ( G.CDGRUPPROD = :CDGRUPPROD )
                    AND ( G.CDSUBGRPROD = E.CDSUBGRPROD (+) )
                GROUP BY
                    G.CDSUBGRPROD,
                    E.CDLOCALESTOQ
                ORDER BY G.CDSUBGRPROD";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    // It executes procedure movimentaEstoque 
    public function executeProcedureMovimentacaoEstoque(
        $cdfilial,
        $cdalmoxarife,
        $cdlocalestoq,
        $nrloteestq,
        $tamnivel,
        $dtinicial,
        $dtfinal,
        $prodini,
        $prodfin,
        $idlancto,
        $idcusto,
        $sequencial
    ) {
        #creates procedure
        $procedure = new StoredProcedure($this->connection, 'MOVIMENTACAO_ESTOQUE');
        
        #sets all parameters
        $procedure->addParam(new Param("P_FILIAL", Param::PARAM_INPUT, $cdfilial, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_CDALMOXARIFE", Param::PARAM_INPUT, $cdalmoxarife, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_CDLOCALESTOQ", Param::PARAM_INPUT, $cdlocalestoq, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_NRLOTEESTQ", Param::PARAM_INPUT, $nrloteestq, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_TAMNIVEL", Param::PARAM_INPUT, $tamnivel, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_DTINICIAL", Param::PARAM_INPUT, $dtinicial, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_DTFINAL", Param::PARAM_INPUT, $dtfinal, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_PRODINI", Param::PARAM_INPUT, $prodini, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_PRODFIM", Param::PARAM_INPUT, $prodfin, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_IDLANCTO", Param::PARAM_INPUT, $idlancto, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_IDCUSTO", Param::PARAM_INPUT, $idcusto, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_SEQUMOVI", Param::PARAM_INPUT, $sequencial, Param::PARAM_TYPE_STR));
        
        #execute procedure
        $procedure->execute();
    }
    
    // 	This function gets stock services data on DB
    public function getStockServicesInfo($params){
    	$sql = "SELECT
                    GP.CDSUBGRPROD             AS CDSUBGRPROD,
                    NVL(SUM(VALRPOSINI), 0)    AS VALRPOSINI,
                    NVL(SUM(VRCONSEMPRESA), 0) AS VRCONSEMPRESA,
                    NVL(SUM(VRCONSPERDA), 0)   AS VRCONSPERDA,
                    NVL(SUM(VRCONSFUNC), 0)    AS VRCONSFUNC,
                    NVL(SUM(VALRPOSFIM), 0)    AS VALRPOSFIM,
                    NVL(SUM(VRFALTAINV), 0)    AS VRFALTAINV,
                    NVL(SUM(VRSOBRAINV), 0)    AS VRSOBRAINV
                FROM
                    SUBGRUPPROD GP,
                    (
                        SELECT
                            CONS.CDSUBGRPROD,
                            CONS.CDLOCALESTRM,
                            CONS.VALRPOSINI,
                            CONS.VRCONSEMPRESA,
                            CONS.VRCONSPERDA,
                            CONS.VRCONSFUNC,
                            F.VALRPOSFIM,
                            FI.VRFALTAINV,
                            SI.VRSOBRAINV
                        FROM
                            (
                                SELECT
                                    R.CDSUBGRPROD,
                                    R.CDLOCALESTRM,
                                    SUM(R.VALRPOSINI)    VALRPOSINI,
                                    SUM(R.VRCONSEMPRESA) VRCONSEMPRESA,
                                    SUM(R.VRCONSPERDA)   VRCONSPERDA,
                                    SUM(R.VRCONSFUNC)    VRCONSFUNC
                                FROM
                                    (
                                        SELECT
                                            AN.CDSUBGRPROD,
                                            P.CDLOCALESTRM,
                                            DECODE(IDTIPOMOVIEST, '-', SUM(VRCUSTMOVIEST), 0)             VALRPOSINI,
                                            DECODE(CDTIPORETIME, '02', SUM(VRCUSTMEDI * QTLANCAMENTO), 0) VRCONSEMPRESA,
                                            DECODE(CDTIPORETIME, '03', SUM(VRCUSTMEDI * QTLANCAMENTO), 0) VRCONSPERDA,
                                            DECODE(CDTIPORETIME, '04', SUM(VRCUSTMEDI * QTLANCAMENTO), 0) VRCONSFUNC
                                        FROM
                                            RELAT_MOVIEST P,
                                            PRSUBGRPROD   AN,
                                            PRODUTO       PR
                                        WHERE
                                            ( P.NRRELATMOVI = :NRRELATMOVI )
                                            AND ( P.CDFILIMOVIEST = :CDFILIAL )
                                            AND ( PR.CDARVPROD = P.CDPRODMOVIEST )
                                            AND ( AN.CDGRUPPROD = :CDGRUPPROD )
                                            AND ( AN.CDPRODUTO = PR.CDPRODUTO )
                                            AND ( AN.CDFILISUBGR = :CDFILISUBGR )
                                        GROUP BY
                                            AN.CDSUBGRPROD,
                                            P.CDLOCALESTRM,
                                            IDTIPOMOVIEST,
                                            CDTIPORETIME
                                    ) R
                                GROUP BY
                                    R.CDSUBGRPROD,
                                    R.CDLOCALESTRM
                            ) CONS,
                            (
                                SELECT
                                    AN.CDSUBGRPROD,
                                    P.CDLOCALESTOQ    AS CDLOCALESTRM,
                                    SUM(P.VRESTOQDIA) AS VALRPOSFIM
                                FROM
                                    POSESTDIA   P,
                                    PRODUTO     A,
                                    PRSUBGRPROD AN
                                WHERE
                                    ( P.CDFILIAL = :CDFILIAL )
                                    AND ( P.CDALMOXARIFE = :CDALMOXARIFE )
                                    AND ( P.CDLOCALESTOQ = :CDLOCALESTOQ )
                                    AND ( AN.CDGRUPPROD = :CDGRUPPROD )
                                    AND ( AN.CDFILISUBGR = :CDFILISUBGR )
                                    AND ( AN.CDPRODUTO = P.CDPRODUTO )
                                    AND ( P.CDPRODUTO = A.CDPRODUTO )
                                    AND ( P.DTPOSIESTQ = (
                                        SELECT
                                            MAX(DTPOSIESTQ)
                                        FROM
                                            POSESTDIA C
                                        WHERE
                                            ( C.CDFILIAL = P.CDFILIAL )
                                            AND ( C.CDPRODUTO = P.CDPRODUTO )
                                            AND ( C.CDALMOXARIFE = P.CDALMOXARIFE )
                                            AND ( C.CDLOCALESTOQ = P.CDLOCALESTOQ )
                                            AND ( C.NRLOTEESTQ = P.NRLOTEESTQ )
                                            AND ( C.NRSUBLOTE = P.NRSUBLOTE )
                                            AND ( C.DTPOSIESTQ <= TO_DATE(:DTPOSIESTQ, 'DD/MM/YYYY') + 1)
                                    ) )
                                GROUP BY
                                    P.CDLOCALESTOQ,
                                    AN.CDSUBGRPROD
                            ) F,
                            (
                                SELECT
                                    AN.CDSUBGRPROD,
                                    P.CDLOCALESTRM,
                                    SUM(QTLANCAMENTO * VRCUSTMEDI) VRFALTAINV
                                FROM
                                    RELAT_MOVIEST P,
                                    PRSUBGRPROD   AN,
                                    PRODUTO       PR
                                WHERE
                                    ( P.NRRELATMOVI = :NRRELATMOVI )
                                    AND ( P.CDFILIMOVIEST = :CDFILIAL )
                                    AND ( PR.CDARVPROD = P.CDPRODMOVIEST )
                                    AND ( AN.CDGRUPPROD = :CDGRUPPROD )
                                    AND ( AN.CDPRODUTO = PR.CDPRODUTO )
                                    AND ( AN.CDFILISUBGR = :CDFILISUBGR )
                                    AND ( P.IDTIPOMOVIEST = '1' )
                                    AND ( P.QTLANCAMENTO < 0 )
                                GROUP BY
                                    AN.CDSUBGRPROD,
                                    P.CDLOCALESTRM
                            ) FI,
                            (
                                SELECT
                                    AN.CDSUBGRPROD,
                                    P.CDLOCALESTRM,
                                    SUM(QTLANCAMENTO * VRCUSTMEDI) VRSOBRAINV
                                FROM
                                    RELAT_MOVIEST P,
                                    PRSUBGRPROD   AN,
                                    PRODUTO       PR
                                WHERE
                                    ( P.NRRELATMOVI = :NRRELATMOVI )
                                    AND ( P.CDFILIMOVIEST = :CDFILIAL )
                                    AND ( PR.CDARVPROD = P.CDPRODMOVIEST )
                                    AND ( AN.CDGRUPPROD = :CDGRUPPROD )
                                    AND ( AN.CDPRODUTO = PR.CDPRODUTO )
                                    AND ( AN.CDFILISUBGR = :CDFILISUBGR )
                                    AND ( P.IDTIPOMOVIEST = '1' )
                                    AND ( P.QTLANCAMENTO > 0 )
                                GROUP BY
                                    AN.CDSUBGRPROD,
                                    P.CDLOCALESTRM
                            ) SI
                        WHERE
                            ( CONS.CDSUBGRPROD = F.CDSUBGRPROD (+) )
                            AND ( CONS.CDLOCALESTRM = F.CDLOCALESTRM (+) )
                            AND ( CONS.CDSUBGRPROD = FI.CDSUBGRPROD (+) )
                            AND ( CONS.CDLOCALESTRM = FI.CDLOCALESTRM (+) )
                            AND ( CONS.CDSUBGRPROD = SI.CDSUBGRPROD (+) )
                            AND ( CONS.CDLOCALESTRM = SI.CDLOCALESTRM (+) )
                    )           P
                WHERE
                        GP.CDGRUPPROD = :CDGRUPPROD
                    AND GP.CDSUBGRPROD = P.CDSUBGRPROD (+)
                GROUP BY
                    GP.CDSUBGRPROD,
                    NMSUBGRPROD,
                    CDLOCALESTRM
                ORDER BY
                    GP.CDSUBGRPROD";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    // 	This function gets checkout counter data on DB
    public function getCheckoutCounterInfo($params){
    	$sql = "SELECT
                    E.VRTICKETCAIXA,
                    E.QTDEITENS,
                    E.QTTICKETCAIXA,
                    E.VRTICKETMEDIO,
                    DECODE(E.QTTICKETCAIXA,0,0,E.QTDEITENS/E.QTTICKETCAIXA) AS QTITPTC
                FROM
                    (
                        SELECT
                            L.CDLOCALESTOQ,
                            NVL(SUM(TRUNC(I.QTPRODVEND *(NVL(I.VRUNITVEND, 0) + NVL(VRUNITVENDCL, 0)), 2) - NVL(VRDESITVEND, 0)), 0) AS VRTICKETCAIXA,
                            NVL(SUM(I.QTPRODVEND), 0) AS QTDEITENS,
                            NVL(COUNT(DISTINCT(V.CDFILIAL || V.CDCAIXA || V.NRSEQVENDA)), 0)  AS QTTICKETCAIXA,
                            NVL(SUM(TRUNC(I.QTPRODVEND *(NVL(I.VRUNITVEND, 0) + NVL(VRUNITVENDCL, 0)), 2) - NVL(VRDESITVEND, 0)), 0) / COUNT(DISTINCT(
                            V.CDFILIAL|| V.CDCAIXA || V.NRSEQVENDA)) AS VRTICKETMEDIO
                        FROM
                            VENDA     V,
                            ITEMVENDA I,
                            LOJA      L
                        WHERE
                            ( V.CDFILIAL = :CDFILIAL )
                            AND ( V.DTENTRVENDA BETWEEN :DTINICIAL AND :DTFINAL )
                            AND ( V.IDSITUVENDA = 'O' )
                            AND ( I.CDFILIAL = V.CDFILIAL )
                            AND ( I.CDCAIXA = V.CDCAIXA )
                            AND ( I.NRSEQVENDA = V.NRSEQVENDA )
                            AND ( V.CDFILIAL = L.CDFILIAL )
                            AND ( V.CDLOJA = L.CDLOJA )
                            AND ( L.CDALMOXARIFE = :CDALMOXARIFE )
                            AND ( L.CDLOCALESTOQ = :CDLOCALESTOQ )
                        GROUP BY
                            L.CDLOCALESTOQ
                    ) E
                ORDER BY
                    E.CDLOCALESTOQ";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
}