var Est44000RecalculoEstoque_Controller = function(ScreenService, General, Est44000RecalculoEstoque_Service, templateManager, ZhFilterPreferences) {
	
	this.setFieldsOnEnter = function(widget){
	    Est44000RecalculoEstoque_Service.getParamFilial().then(function(paramfilial){
	    	var row = widget.currentRow;
	        paramfilial = paramfilial.dataset.paramfilial[0];
	        var fieldAlmox = widget.getField('DSALMOXARIFE');
	        var fieldLocal = widget.getField('DSLOCALESTOQ');
	        if(paramfilial.IDUTILALMOX == 'S'){
            	row.CDALMOXARIFE = null;
	            fieldAlmox.readOnly = false;
	            if(paramfilial.IDUTILLCESTQ == 'S'){
	            	row.CDLOCALESTOQ = null;
	                fieldLocal.readOnly = false;
	            }else{
	            	row.CDLOCALESTOQ = ' ';
	                fieldLocal.readOnly = true;
	            }
	        }else{
            	row.CDLOCALESTOQ = ' ';
            	row.CDALMOXARIFE = ' ';
	            fieldAlmox.readOnly = true;
	            fieldLocal.readOnly = true;
	        }
	        this.getFilialLogada().then(function(success){
	        	row.CDFILIAL = success.dataset.filial[0].CDFILIAL;
	        	row.NMFILIAL = success.dataset.filial[0].NMFILIAL;
				this.filialOnChange(widget);
	        }.bind(this));
		}.bind(this));
	};
	
	this.getFilialLogada = function() {
        var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": "FILIAL_LOGADA"
                }
		    ];
        return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };
	
	this.recalcularEstoque = function(widget){
		var row = widget.currentRow;
		row.CDPRODFIN = row.CDPRODFIN + "zzzzzzzzzzzzzzzzzzz";
        row.CDPRODFIN = row.CDPRODFIN.substring(0, 20);
		if(widget.isValid()){
			if(!General.comparaPratoProduto(row.CDPRODINI,row.CDPRODFIN,getLocalVar('GER_CDPICTPROD'))){
				ScreenService.showMessage('Produto inicial deve ser menor ou igual ao produto final.');
			}else{
				ScreenService.showLoader();
				Est44000RecalculoEstoque_Service.recalcularEstoque(row).then(function(success){
					ScreenService.showMessage('Recálculo de estoque foi realizado com sucesso.');
					ScreenService.hideLoader();
				},function(error){
					error = error.data.error;
					if(typeof error == 'object'){
						Est44000RecalculoEstoque_Service.saveProdutosIrregulares(error).then(function(saved){
							ScreenService.openWindow('est_ajuste#est44001_produtos_irregulares_recalculo');
							ScreenService.hideLoader();
						});
					}else{
						ScreenService.showMessage(error);
						ScreenService.hideLoader();
					}
				});
			}
		}
    };
    
    this.apagaValorAlmoxarifado = function(widget,codigo, nome){
        widget.currentRow[codigo] ='';
        widget.currentRow[nome] ='';
    };

    this.filialOnChange = widget => {
        widget.getField('DSALMOXARIFE').reload();
        General.callRestEngine('est#/crud/paramfilial', "FilterData", [{"name": "CDFILIAL", "operator": "=", "value": widget.currentRow.CDFILIAL}]).then((success) => {
        	if(success.dataset.paramfilial[0].IDUTILALMOX == 'S') {
        		widget.getField('DSALMOXARIFE').readOnly = false;
        		widget.currentRow.controlaLocal = success.dataset.paramfilial[0].IDUTILLCESTQ;
        	}
        	this.apagaValorAlmoxarifado(widget,'CDALMOXARIFE','DSALMOXARIFE');
	        widget.getField('NMPRODINI').dataSourceFilter.forEach(function(fil){
	        	if(fil.name == 'CDFILIAL'){
	        		fil.value = widget.currentRow.CDFILIAL;
	        	}
	        });
	        widget.getField('NMPRODFIN').dataSourceFilter.forEach(function(fil){
	        	if(fil.name == 'CDFILIAL'){
	        		fil.value = widget.currentRow.CDFILIAL;
	        	}
	        });
	        widget.getField('NMPRODINI').reload();
	        widget.getField('NMPRODFIN').reload();
        	
        });
       
    };
    
    this.checkProductRange = function (field) {
        var currentRow = field.widget.currentRow;

        if (currentRow.CDPRODINI && currentRow.CDPRODFIN) {
            var compproduto = currentRow.CDPRODFIN ? currentRow.CDPRODFIN.replace(/[\.\-]/g, '') : null;

            if (!General.comparaPratoProduto(currentRow.CDPRODINI, compproduto, getLocalVar('CDPICTPROD'))) {
                currentRow[field.outData[field.descriptionField]] = null;
                currentRow[field.outData[field.valueField]] = null;
                field.clearValue();
                field.reload();
                
				ScreenService.showMessage("O Produto Final não pode ser maior que o Produto Inicial.");
            }
        }
    };
    
    this.almoxarifadoOnChange = (args) => {
    	let widget = args.owner.field.widget;
    	if(widget.currentRow.DSALMOXARIFE && widget.currentRow.controlaLocal == 'S') {
    		widget.getField('DSLOCALESTOQ').readOnly = false;
    	}	
    	else {
    		widget.getField('DSLOCALESTOQ').readOnly = true;
    	}
    	widget.getField('DSLOCALESTOQ').value('');
    	widget.getField('DSLOCALESTOQ').reload();
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Est44000RecalculoEstoque_Controller', Est44000RecalculoEstoque_Controller);
});
