const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const j = require('../../json/leitorJson.po.js');
const retiradaDeEstoquePage = require('../../page-objects/estoque/retiradaDeEstoque.po.js');
const caminho = ["Estoque", "Retirada de Estoque"];

describe('Retirada de estoque com controle de estoque/lote/Almoxarifado', function () {

  beforeAll(async function(){
  	await loginPage.login(j.getValor('login'), j.getValor('senha'), j.getValor('url'));
  });

  afterAll(async function(){
  	browser.driver.quit();
  });

  it('Verifica se página acessada é a de Retirada de estoque', function(){
  	retiradaDeEstoquePage.abrir();
  	expect(z.component.header.getTitle()).toBe(j.getValor('telaEmTeste'));
  });

  it('Inserir retirada de estoque com controle de estoque, almoxarifado e lote', function(){
  	geral.clickAdicionar();
  	retiradaDeEstoquePage.validaValorEmEdicao();
  	retiradaDeEstoquePage.inserirAbaRetiradaDeEstoque();

  	expect(geral.gridHasText(j.getValor('gridPrincipal'), 'Retirada de estoque realizada por script de teste.', 2, )).toBe(j.getValor('textoDescricao'));
  	});
});